(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('react'), require('react-router')) :
  typeof define === 'function' && define.amd ? define(['exports', 'react', 'react-router'], factory) :
  (factory((global['ssr-fetch-data'] = {}),global.React,global.reactRouter));
}(this, (function (exports,React,reactRouter) { 'use strict';

  React = React && React.hasOwnProperty('default') ? React['default'] : React;

  var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

  var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

  function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

  function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

  function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

  function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
  var executeFetchData = require('../executeFetchData');
  var hoistNonReactStatics = require('hoist-non-react-statics');
  var PrerenderContext = require('../context');
  require('regenerator-runtime/runtime.js');

  var ssrFetchData = function ssrFetchData(DecoratedComponent) {
    var _class;

    var ssrFetchData = reactRouter.withRouter(_class = function (_React$Component) {
      _inherits(ssrFetchData, _React$Component);

      function ssrFetchData() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, ssrFetchData);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = ssrFetchData.__proto__ || Object.getPrototypeOf(ssrFetchData)).call.apply(_ref, [this].concat(args))), _this), _this.loaderRequired = false, _this.error = false, _this.clientFetchedData = null, _this.state = {
          fetched: false,
          params: _this.props.match.params
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(ssrFetchData, [{
        key: 'fetchData',
        value: function () {
          var _ref2 = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
            var props;
            return regeneratorRuntime.wrap(function _callee$(_context) {
              while (1) {
                switch (_context.prev = _context.next) {
                  case 0:
                    _context.prev = 0;
                    _context.next = 3;
                    return executeFetchData(DecoratedComponent, this.props.match);

                  case 3:
                    props = _context.sent;

                    this.clientFetchedData = props[DecoratedComponent.displayName];
                    this.error = false;
                    this.setState({ fetched: true });
                    _context.next = 14;
                    break;

                  case 9:
                    _context.prev = 9;
                    _context.t0 = _context['catch'](0);

                    console.warn('Failed to fetch some props for fetchData. Rendering anyway...', _context.t0);
                    this.error = true;
                    this.setState({ fetched: true });

                  case 14:
                  case 'end':
                    return _context.stop();
                }
              }
            }, _callee, this, [[0, 9]]);
          }));

          function fetchData() {
            return _ref2.apply(this, arguments);
          }

          return fetchData;
        }()
      }, {
        key: 'extractFromWindow',
        value: function extractFromWindow() {
          var hydratedData = window._hydratedData || {};
          return hydratedData[DecoratedComponent.displayName];
        }
      }, {
        key: 'render',
        value: function render() {
          var _this2 = this;

          return React.createElement(
            PrerenderContext.PrerenderConsumer,
            null,
            function () {
              var componentProps = _this2.clientFetchedData || _this2.extractFromWindow();

              if (!componentProps) {
                _this2.fetchData();
                _this2.loaderRequired = true;
              }

              var loading = !_this2.state.fetched && _this2.loaderRequired && !_this2.props.disableFetchData;
              var error = _this2.error && !_this2.props.disableFetchData;
              return React.createElement(DecoratedComponent, _extends({}, _this2.props, componentProps, { loading: loading, error: error, retryFetchData: _this2.fetchData.bind(_this2) }));
            }
          );
        }
      }]);

      return ssrFetchData;
    }(React.Component)) || _class;

    /** Defines what JSX components we need to fetchData for */


    ssrFetchData.ssrWaitsFor = DecoratedComponent.ssrWaitsFor;
    /** Unique name for this component, to use for checking on window state */
    ssrFetchData.displayName = DecoratedComponent.displayName || DecoratedComponent.name;
    /** Make the static fetchData method available, pass through, as HOCs lose statics */
    ssrFetchData.fetchData = DecoratedComponent.fetchData;

    return hoistNonReactStatics(ssrFetchData, DecoratedComponent);
  };

  exports.PrerenderContext = PrerenderContext;
  exports.default = ssrFetchData;

  Object.defineProperty(exports, '__esModule', { value: true });

})));
